//------------------------------------------------------------------------
//   10 `\̂ɂrbgtB[h`
//                                                           PIC16F1827p
//                                            filename: ex10_bit.c
//------------------------------------------------------------------------
#include <16f1827.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,NOCPD,NOMCLR,BROWNOUT,NOPUT
#fuses NOIESO,NOFCMEN,PLL_SW,NOLVP,NOSTVREN
#use delay(clock=8MHZ)

struct bitset {						// bitsetƂÕrbgtB[h錾(\̐錾)
 	byte  led1 : 1;					// bit0:(LSB) LED1(SW1ON/OFFj^)
	byte  led2 : 1;					// bit1:      LED2(SW2ON/OFFj^)
    byte  led3 : 1;					// bit2:      LED3(LED1̔])
	byte  led4 : 1;					// bit3:      LED4(LED2̔])
	byte  sw1  : 1;					// bit4:	  XCb`1(SW1)
 	byte  sw2  : 1;					// bit5:	  XCb`2(SW2)
	byte  res  : 2;					// bit6,7:(MSB) gp
 };
struct  bitset  RB;					// bitset^̕ϐRB̌^錾(ϐRB͍\)
#byte  RB = 0x0d					// ϐRBɃ|[gB(RB)蓖āC|[gAhX0x0dԒn
#byte  RA = 0x0c					// |[gA(RA)̃AhX0x0cԒn

//------------------------------------------------------------------------
//   C֐
//------------------------------------------------------------------------
void main(void) {
	setup_oscillator(OSC_8MHZ);		// NbN8MHzɐݒ
	set_tris_a(0xff);				// f[^̓o͕ݒC|[gA͑Sē
	set_tris_b(0xf0);				// f[^̓o͕ݒC4bit(),4bit(o)

	RB = 0;							// |[gB̃[NA
   while(1) {
	  RB.led1 = RB.sw1;				// SW1ON/OFFLED1ɏo
	  RB.led2 = RB.sw2;				// SW2ON/OFFLED2ɏo
	  RB.led3 = ~RB.sw1;			// LED1rbg]
	  RB.led4 = ~RB.sw2;			// LED1rbg]
	}
 }									// end of main()

