//------------------------------------------------------------------------
//   24  ^b`ZT(ÓdeʎZVOW[)̊p        PIC16F1827p
//           5: CPS0(RA0),CPS1(RA1),CPS2(RA2),CPS3(RA3),CPS4(RA4)
//           j^pLED: RB0,RB1,RB2,RB3,RB4
//                                             filename: ex24_touch.c
//------------------------------------------------------------------------
#include <16f1827.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,NOCPD,NOMCLR,BROWNOUT,NOPUT
#fuses NOIESO,NOFCMEN,PLL_SW,NOLVP,NOSTVREN,BORV25,NODEBUG
#use delay(clock=8MHZ)					// NbNg8MHz
#use touchpad(THRESHOLD=30,SCANTIME=10MS,PIN_A0='A',PIN_A1='B',PIN_A2='C',PIN_A3='D',PIN_A4='E')

//------------------------------------------------------------------------
//          I/O|[g̒`
//------------------------------------------------------------------------
#byte  RA = 0x0c						// |[gA(RA)̃AhX0x0cԒn
#byte  RB = 0x0d						// |[gB(RB)̃AhX0x0dԒn
//------------------------------------------------------------------------
//          C֐
//------------------------------------------------------------------------
void main(void) {
	char c;
	setup_oscillator(OSC_8MHZ);			// NbN8MHzɐݒ
	set_tris_a(0xff);					// |[gA͑Sē
	set_tris_b(0x00);					// |[gB͑Sďo

	touchpad_state(1);					// CSMLu[VCʏ
	enable_interrupts(GLOBAL);			// Ŝ̋
    c='F';								// ڐG̓LN^'F'

	while(1) {
	   if(touchpad_hit()) {				// ^b`dɂɐGꂽȉs
		  c = touchpad_getc();			// ڐG^b`dɂ̃`l擾
	      switch(c) {
			case 'A': RB = 1; break;	// CPS0ɐڐGȂRB0_
			case 'B': RB = 2; break;	// CPS1ɐڐGȂRB1_
			case 'C': RB = 4; break;	// CPS2ɐڐGȂRB2_
			case 'D': RB = 8; break;	// CPS3ɐڐGȂRB3_
			case 'E': RB =16; break;	// CPS4ɐڐGȂRB4_
			default:  RB = 0;			// OCO͑Sď
	       }
	    }
     }
 }
