//----------------------------------------------------------
//  PIC}CRpLCDCu֐   [lcd_lib.h]
//  (16~2s SC1602BS*Bp)
//                                     Ver.3.0  N.Takada
//----------------------------------------------------------
// 		RB0: D4 f[^       RB4: E  (Cl[uCLCDW[̑I)
//		RB1: D5 f[^	   RB5: RS (WX^ZNgCR}h/f[^̐؂ւ)
//		RB2: D6 f[^	   RB6: NC (gp)
//		RB3: D7 f[^	   RB7: NCigp)
//----------------------------------------------------------
// LCDpO[oϐI/O|[g̒`
 struct  byte8							// byte8͍\̌^̐錾
	{	byte  db4:4;					// LCDf[^oX(4bit)p, Lsb
		byte  e  :1;					// LCDCl[uM
	 	byte  rs :1;					// LCDWX^ZNgM
		byte  res:2;					// gp(U[u)CMsb
	};
 struct  byte8  RB;						// ϐRBbyte8^
//   #byte  RB = 0x0d					// RB̓|[gB̃AhX0x0dԒnɐݒ
										// RB̒`̓C֐ōsĉ
//---------------------------------------------------
//  vg^Cv錾
//---------------------------------------------------
void outst(char s);						// LCD֐CJ[\̈ʒu當\
void outc(char c);						// LCD֐CJ[\̈ʒu1o
void outi(signed long i);      			// LCD֐Ct(-32767`32767)̕\
void outf(float f);         			// LCD֐Cfloat^̕\
void outhex(long fnum, byte dg); 		// 2bytef[^16i\֐Cdg͕\(1`4)
void outbin(byte num);	        		// 1bytef[^2i\֐
void locate(byte x, byte y);		  	// LCD̃J[\ړCx=0`15 y=0,1
void clr_lcd(void);						// LCD֐Ct̑SʃNA
void initlcd(void);         			// LCDW[̏
//--------------------------------------[ȉ̊֐sub֐]
void out4(byte code4, byte rs0);		// codẻ4bitLCD֓],rs0RSɓn
void out8(char code8, byte rs0);		// code 1ByteLCD֓],rs0RSɓn
void outhex1(byte num);					// 16i1\o

//---------------------------------------------------
//  e֐̒`
//---------------------------------------------------
void initlcd(void){						// LCD̏
   delay_ms(15);						// 15msԑ҂
   out4(0x03, 0); delay_ms(5);   		// WX^ZNg,4.2msԑ҂
   out4(0x03, 0); delay_us(100);		// WX^ZNg,100usԑ҂
   out4(0x03, 0); delay_us(40);			// WX^ZNg,40usԑ҂
   out4(0x02, 0); delay_us(40);			// 40usԑ҂

   out8(0x28, 0);   					// function set(0x28=0010 1000)
  	 	// DL=0(4bit data),N=1(2 line),F=0(5*7dots font) '001(DL)NF**'
   out8(0x0c, 0);						// display on off control(0x0c=0000 1100)
      	// D=1(display on),C=0(cursol off),B=0(cursol not blink) '0000 1DCB'
   out8(0x06, 0);   					// entry mode set(0x06=0000 0110)
      	// (I/D)=1(increment),S=0(display shift) '0000 01(I/D)S'
   clr_lcd();       					// tʂ̃NA
}


void out4(byte code4, byte rs0){
   RB.db4 = code4;						// code4̉4bitf[^[qD4-7ɏo
   RB.rs  = rs0; delay_us(2);        	// RSݒ(1:f[^C0:R}h)
   RB.e   = 1;   delay_us(2);			// E = 'H'
   RB.e   = 0;   delay_us(2);	        // E = 'L'
}


void out8(char code8, char rs0){
   out4((0xf0 & code8)/0x10, rs0); 		// code8̏4bito
   out4(0x0f & code8, rs0);        		// code8̉4bito
   delay_us(40);						// 40us̎ԑ҂
}


void locate(byte x, byte y){			// t̃J[\ʒuݒ
   out8(0x80+x+y*0x40, 0);
}


void outst(char s){						// tɕ𑗂
      out8(s, 1);
 }


void outc(char c) {						// 1o
	out8(c,1);
 }


void outi(signed long i){				// t16rbg̉to
   signed long j;
   byte k=0;
   char s[6];
   j = i;
   if(j==0) out8('0',1);				// 0Ȃ0\
   else {
      if(j<0){							// Ȃ畉̕\
         out8('-',1);
         j=-j;
       }
      while(0 < j){
         s[k++]=j-((long)(j/10)*10);
         j=(long)j/10;	
      }
      while(k != 0){
		 k -= 1;
         out8('0'+s[k],1);
      }
   }
}


void outf(float f){						// _̉t\
   long h,l;
   if(f<0){
      out8('-',1);						// Ȃ-L\
      f = -f;							// Βlɕϊ
   }
   h=(long)f;
   outi(h);								// ݂̂̂\
   out8('.',1);							// _\
   l=(long)((f-(float)h)*1000.);		// O3o
   if(l<100) outi(0);					// 1ʂ̃[\
   if(l<10)  outi(0);					// 2ʂ̃[\
   outi(l);								// l̕\
 }


void clr_lcd(void){					   	// tʂ̃NA
   out8(0x01, 0); delay_ms(2);			// 2msԑ҂
 }


void outhex1(byte num) {    			// 16i1\o
    if(num < 10) out8('0'+num,1);
     else        out8('a'+num-10,1);
 }


void outhex(long fnum, byte dg) 		// 16i\֐
 {										// 1:f[^C2:\(1`4)
    if(dg > 4) dg = 4;
    if(dg== 0) dg = 1;
    switch(dg) {
      case 4: outhex1((fnum & 0xf000) >> 12);	// 4\
      case 3: outhex1((fnum & 0x0f00) >> 8);	// 3\
      case 2: outhex1((fnum & 0x00f0) >> 4);	// 2\
      case 1: outhex1((fnum & 0x000f));			// 1\
     }
 }


void outbin(byte num) {        			// 1bytef[^2i\֐
    byte icnt;
    for(icnt=0; icnt < 8; icnt++) {
      if(num & 0x80) outi(1);
       else          outi(0);
       num <<= 1;
     }
 }

